<?php
require 'constants.php';
require 'header.php';

echo "  <h1>Administrator: Add Winning DKP Bid</h1>\n";

if (stripslashes($_POST['name']) == '' || stripslashes($_POST['dkp']) == '' || (stripslashes($_POST['item-menu']) == 'Item entered in text field:' && stripslashes($_POST['item-field']) == '')) {
	echo "  <p class=\"error\">Some required fields were not filled out.</p>
		<p class=\"goback\">Return to the <a href=\"add-bid.php\">Add Bid</a> page.</p>\n";
}
else if (verifyPassword($db, stripslashes($_POST['password']), array(PERM_MODIFY_DKP => TRUE))) {
	begin($db);

	/* First we determine a unique ID for the new entry. */

	$result = pg_query($db, "SELECT MAX(change_id) FROM DKP;");
	if (!$result) { echo "  <p class\"error\">Could not obtain a unique change ID: " . pg_last_error($db); require 'footer.php'; exit; }
	if (pg_num_rows($result)) {
		// if there is at least one entry, the unique ID is 1 + the highest existing ID
		$row = pg_fetch_row($result);
		if ($row[0] == NULL) $changeID = 0; // otherwise start at zero
		else $changeID = $row[0] + 1;
	}
	else { echo "  <p class\"error\">Querying the maximum change_id for DKP unexpectedly returned no rows.</p>\n"; require 'footer.php'; exit; }

	/* Now insert the DKP deduction into the DKP table. */

	$query = "INSERT INTO DKP (change_id,raid_id,amount,name) VALUES (" . pg_escape_string($changeID) . ", " . pg_escape_string(stripslashes($_POST['raid'])) . "," . pg_escape_string(stripslashes($_POST['dkp'])) . ",'" . pg_escape_string(stripslashes($_POST['name'])) . "');";
	$result = pg_query($db, $query);
	if (!$result) { echo "  <p class=\"error\">Could not insert a new DKP entry for the winning bid: " . pg_last_error($db); require 'footer.php'; exit; }

	/* Record the item won in the Items table, if necessary. */

	$item = '(unknown item)';
	if (stripslashes($_POST['item-menu']) == 'Item entered in text field:') $item = stripslashes($_POST['item-field']);
	else $item = stripslashes($_POST['item-menu']);
	$query = "SELECT * FROM Items WHERE item='" . pg_escape_string($item) . "';";
	$result = pg_query($db, $query);
	if (!$result) { echo "  <p class=\"error\">Could not query Items table to determine if the item \"" . stripslashes($item) . "\" is already in the table: " . pg_last_error($db); require 'footer.php'; exit; }
	if (pg_num_rows($result) == 0) {
		// it's not in the table, add it
		$url = "http://www.thottbot.com/?s=" . urlencode(stripslashes($item));
		$query = "INSERT INTO Items (item, url) VALUES ('" . pg_escape_string($item) . "', '". pg_escape_string($url). "');";
		$result = pg_query($db, $query);
		if (!$result) { echo "  <p class=\"error\">Could not create new <code>Items</code> entry for the item \"" . stripslashes($item) . "\": " . pg_last_error($db); require 'footer.php'; exit; }
	}

	/* Record an entry in the Bids table corresponding to the entry in the DKP table, and associate it with the item won in the Items table. */

	$query = "INSERT INTO Bids (change_id, item) VALUES (" . pg_escape_string($changeID) . ", '" . pg_escape_string($item) . "');";
	$result = pg_query($db, $query);
	if (!$result) { echo "  <p class=\"error\">Could not add the <code>Bids</code> entry for the item \"" . stripslashes($item) . "\": " . pg_last_error($db); require 'footer.php'; exit; }

	commit($db);
	echo "  <p>" . stripslashes($_POST['name']) . "'s winning bid for " . stripslashes($item) . " was successfully added.</p>
		<p class=\"goback\"><a href=\"add-bid.php\">Add another bid</a> or return to the <a href=\"index.php\">Player List</a>.</p>";
}
else {
	echo "  <p class=\"error\">The supplied administrator password was incorrect.</p>
		<p class=\"goback\">Return to the <a href=\"add-bid.php\">Add Bid</a> page.</p>";
}

require 'footer.php';
?>
