<?php
require 'constants.php';
require 'header.php';

echo "  <h1>Administrator: Add Credit from Existing Raid</h1>\n";

if (stripslashes($_POST['name']) == '' || stripslashes($_POST['dkp']) == '' || stripslashes($_POST['raid']) == '') {
	echo "  <p class=\"error\">Some required fields were not filled out.</p>
		<p class=\"goback\">Return to the <a href=\"add-credit.php\">Add Credit</a> page.</p>";
}
else if (verifyPassword($db, stripslashes($_POST['password']), array(PERM_MODIFY_DKP => TRUE))) {
	begin($db);

	/* First we determine a unique ID for the new entry. */

	$result = pg_query($db, "SELECT MAX(change_id) FROM DKP;");
	if (!$result) { echo "  <p class\"error\">Could not obtain a unique change ID: " . pg_last_error($db); require 'footer.php'; exit; }
	if (pg_num_rows($result)) {
		// if there is at least one entry, the unique ID is 1 + the highest existing ID
		$row = pg_fetch_row($result);
		if ($row[0] == NULL) $changeID = 0; // otherwise start at zero
		else $changeID = $row[0] + 1;
	}
	else { echo "  <p class\"error\">Querying the maximum change_id for DKP unexpectedly returned no rows.</p>\n"; require 'footer.php'; exit; }

	/* Now insert the DKP credit into the DKP table. */

	$query = "INSERT INTO DKP (change_id,raid_id,amount,name) VALUES (" . pg_escape_string($changeID) . ", " . pg_escape_string(stripslashes($_POST['raid'])) . "," . pg_escape_string(stripslashes($_POST['dkp'])) . ",'" . pg_escape_string(stripslashes($_POST['name'])) . "');";
	$result = pg_query($db, $query);
	if (!$result) { echo "  <p class=\"error\">Could not insert a new DKP entry for the credit: " . pg_last_error($db); require 'footer.php'; exit; } 

	commit($db);
	echo "  <p>" . stripslashes($_POST['name']) . "'s credit was successfully added.</p>
		<p class=\"goback\">Return to the <a href=\"index.php\">Player List</a>.</p>";
}
else {
	echo "  <p class=\"error\">The supplied administrator password was incorrect.</p>
		<p class=\"goback\">Return to the <a href=\"add-credit.php\">Add Credit</a> page.</p>";
}

require 'footer.php';
?>
