<?php
require 'constants.php';
require 'header.php';

echo "  <h1>Administrator: Edit DKP Entry</h1>\n";

if (stripslashes($_POST['amount']) == '' || stripslashes($_POST['raid']) == '' || stripslashes($_POST['id']) == '') {
	echo "  <p class=\"error\">Some required fields were not filled out.</p>
		<p class=\"goback\">Return to the <a href=\"edit-dkp.php?id=" . stripslashes($_POST['id']) . "\">Edit DKP</a> page.</p>";
}
else if (verifyPassword($db, stripslashes($_POST['password']), array(PERM_MODIFY_DKP => TRUE))) {
	begin($db);

	/* We need to know if we are editing a bid or a credit. */

	if (stripslashes($_POST['item'])) {

		/* If it's a bid, we could have to add an entry to the Items table, or possibly modify an entry in the Bids table. */

		$item = stripslashes($_POST['item']);
		$query = "SELECT item FROM Items WHERE item='" . pg_escape_string($item) . "';";
		$result = pg_query($db, $query);
		if (!$result) { echo "  <p class=\"error\">Could not determine if the item already exists in the Items table: " . pg_last_error($db); require 'footer.php'; exit; }
		if (pg_num_rows($result) == 0) { // if the item is not already in the Items table
			// add it to the Items table
			$url = "http://thottbot.com/?s=" . urlencode(stripslashes($_POST['item']));
			$query = "INSERT INTO Items (item, url) VALUES ('" . pg_escape_string($item) . "','" . pg_escape_string($url) . "');";
			$result = pg_query($db, $query);
			if (!$result) { echo "  <p class=\"error\">Could not add the new entry to the Items table: " . pg_last_error($db); require 'footer.php'; exit; }
		}
		// update the Bids entry
		$query = "UPDATE Bids SET item='" . pg_escape_string($item) . "' WHERE change_id = " . pg_escape_string(stripslashes($_POST['id'])) . ";";
		$result = pg_query($db, $query);
		if (!$result) { echo "  <p class=\"error\">Could not update the entry in the Bids table: " . pg_last_error($db); require 'footer.php'; exit; }
	}

	// updat the DKP entry
	$query = "UPDATE DKP SET amount=" . pg_escape_string(stripslashes($_POST['amount'])) . ", raid_id=" . pg_escape_string(stripslashes($_POST['raid'])) . " WHERE change_id=" . pg_escape_string(stripslashes($_POST['id'])) . ";";
	$result = pg_query($db, $query);
	if (!$result) { echo "  <p class=\"error\">Could not update the entry in the DKP table: " . pg_last_error($db); require 'footer.php'; exit; }

	commit($db);
	echo "  <p>DKP entry successfully updated.</p>
		<p class=\"goback\">Return to the <a href=\"index.php\">Player List</a>.</p>";
}
else {
	echo "  <p class=\"error\">The supplied administrator password was incorrect.</p>
		<p class=\"goback\">Return to the <a href=\"edit-dkp.php?id=" . stripslashes($_POST['id']) . "\">Edit DKP Entry</a> page.</p>";
}

require 'footer.php';
?>
