<?php
require 'constants.php';
require 'header.php';

echo "  <h1>Administrator: Edit Raid</h1>\n";

if (stripslashes($_POST['instance']) == '' || stripslashes($_POST['date']) == '' || stripslashes($_POST['note']) == '' || stripslashes($_POST['id']) == '') {
	echo "  <p class=\"error\">Some required fields were not filled out.</p>
		<p class=\"goback\">Return to the <a href=\"edit-raid.php?id=" . stripslashes($_POST['id']) . "\">Edit Raid</a> page.</p>";
}
else if (verifyPassword($db, stripslashes($_POST['password']), array(PERM_MODIFY_DKP => TRUE))) {
	begin($db);

	/* Update the entry in the Raids table. */

	$query = "UPDATE Raids SET instance='" . pg_escape_string(stripslashes($_POST['instance'])) . "', date='" . pg_escape_string(stripslashes($_POST['date'])) . "', note='" . pg_escape_string(stripslashes($_POST['note'])) . "' WHERE raid_id=" . pg_escape_string(stripslashes($_POST['id'])) . ";";
	$result = pg_query($db, $query);
	if (!$result) { echo "  <p class=\"error\">Could not update entry in Raids table: " . pg_last_error($db); require 'footer.php'; exit; }

	/* Add/update/remove players from the raid. */

	// get list of players
	$namesResult = pg_query($db, "SELECT name FROM Players;");
	if (!$namesResult) { echo "  <p class=\"error\">Could not query list of players from Players table: " . pg_last_error($db); require 'footer.php'; exit; }
	// add/edit/remove dkp for each player
	echo "  <p>\n";

	while ($row = pg_fetch_row($namesResult)) {
		$curName = $row[0];
		if (stripslashes($_POST["dkp-$curName"]) == 0) { // if they have no DKP now
			$dkpCheckResult = pg_query($db, "SELECT D.change_id FROM DKP D LEFT OUTER JOIN Bids B ON B.change_id = D.change_id WHERE B.change_id IS NULL AND D.raid_id=" . pg_escape_string(stripslashes($_POST['id'])) . " AND D.name='" . pg_escape_string($curName) . "';");
			if (!$dkpCheckResult) { echo "   <span class=\"error\">Could not check a if $curName formerly had a DKP entry: " . pg_last_error($db); require 'footer.php'; exit; }
			while ($dkpRow = pg_fetch_row($dkpCheckResult)) { // but they used to have DKP
				$deleteResult = pg_query($db, "DELETE FROM DKP WHERE change_id=" . pg_escape_string($dkpRow[0]) . ";");
				if (!$deleteResult) { echo "   <span class=\"error\">Could not remove $curName's DKP entry: " . pg_last_error($db); require 'footer.php'; exit; }
				else echo "   $curName had a credit but does not now; credit deleted.<br />\n";
			}
		}
		else { // if they have DKP now
			$dkpCheckResult = pg_query($db, "SELECT D.change_id, D.amount FROM DKP D LEFT OUTER JOIN Bids B ON B.change_id = D.change_id WHERE B.change_id IS NULL AND D.raid_id=" . pg_escape_string(stripslashes($_POST['id'])) . " AND D.name='" . pg_escape_string($curName) . "';");
			if (!$dkpCheckResult) { echo "   <span class=\"error\">Could not check a if $curName formerly had a DKP entry: " . pg_last_error($db); require 'footer.php'; exit; }
			$row = pg_fetch_row($dkpCheckResult);
			if (pg_num_rows($dkpCheckResult) == 0) { // but they used to not

				// determine first change id that's free to use
				$result = pg_query($db, "SELECT MAX(change_id) FROM DKP;");
				if (!$result) { echo "  <p class\"error\">Could not obtain a unique change ID: " . pg_last_error($db); require 'footer.php'; exit; }
				if (pg_num_rows($result)) {
					// if there is at least one entry, the unique ID is 1 + the highest existing ID
					$row = pg_fetch_row($result);
					if ($row[0] == NULL) $changeID = 0; // otherwise start at zero
					else $changeID = $row[0] + 1;
				}
				else { echo "  <p class\"error\">Querying the maximum change ID for DKP unexpectedly returned no rows.</p>\n"; require 'footer.php'; exit; }

				// add the dkp entry  
				$query = "INSERT INTO DKP (change_id,raid_id,amount,name) VALUES (" . pg_escape_string($changeID) . ", " . pg_escape_string(stripslashes($_POST['id'])) . ", " . pg_escape_string(stripslashes($_POST["dkp-$curName"])) . ", '" . pg_escape_string($curName) . "');";
				$dkpInsertResult = pg_query($db, $query);
				if (!$dkpInsertResult) { echo "   <span class\"error\">Could not insert a new DKP entry for $curName: " . pg_last_error($db); require 'footer.php'; exit; }
				else echo "   $curName did not have a credit but does now; credit added.<br />\n";
			}
			else if (stripslashes($_POST["dkp-$curName"]) != $row[1]) { // and they used to have DKP, and have a different amount now
				$dkpUpdateResult = pg_query($db, "UPDATE DKP SET amount=" . pg_escape_string(stripslashes($_POST["dkp-$curName"])) . " WHERE change_id=" . pg_escape_string($row[0]) . ";");
				if (!$dkpUpdateResult) { echo "   <span class\"error\">Could not update a DKP entry for $curName: " . pg_last_error($db); require 'footer.php'; exit; }
				else echo "   $curName has an altered credit; credit changed.<br />\n";
			}
		}
	}

	commit($db);
	echo "  </p>
		<p>DKP successfully updated to reflect the altered " . stripslashes($_POST['instance']) . " run.</p>
		<p class=\"goback\">Return to the <a href=\"index.php?show=raids\">Raid List</a>.</p>";
}
else {
	echo "  <p class=\"error\">The supplied administrator password was incorrect.</p>
		<p class=\"goback\">Return to the <a href=\"edit-raid.php?id=" . stripslashes($_POST['id']) . "\">Edit Raid</a> page.</p>";
}

require 'footer.php';
?>
