<?php

$sort = 'item';
if (stripslashes($_GET['sort']) == 'value') $sort = 'value';
if (stripslashes($_GET['sort']) == 'drops') $sort = 'drops';
if (stripslashes($_GET['sort']) == 'set') $sort = 'set';

$query = "SELECT I.item, TO_CHAR(AVG(D.amount),'MI999D99') AS value, COUNT(1) AS drops, AVG(D.amount) AS valnum, S.name FROM Items I, Sets S, DKP D INNER JOIN Bids B ON B.change_id = D.change_id WHERE I.item = B.item AND I.set_id = S.id GROUP BY I.item, S.name, S.tier, S.class ";
if ($sort == 'value') $query .= 'ORDER BY valnum ASC, I.item ASC;';
else if ($sort == 'drops') $query .= 'ORDER BY drops DESC, I.item ASC;';
else if ($sort == 'set') $query .= 'ORDER BY S.tier ASC, S.class ASC, I.item ASC;';
else $query .= 'ORDER BY I.item ASC;';

$result = pg_query($db, $query);
if (!$result) { echo "  <p class=\"error\">Couldn't get item information: " . pg_last_error($db) . "</p>\n"; require 'footer.php'; exit; }

echo "
<table>
<tr>\n";

if ($sort == 'item') echo "    <th class=\"primary\">Item</th>\n";
else echo "    <th><a href=\"index.php?show=items\">Item</a></th>\n";
if ($sort == 'value') echo "    <th class=\"primary\">Avg Value</th>\n";
else echo "    <th><a href=\"index.php?show=items&amp;sort=value\">Avg Value</a></th>\n";
if ($sort == 'drops') echo "    <th class=\"primary\">Drops</th>\n";
else echo "    <th><a href=\"index.php?show=items&amp;sort=drops\">Drops</a></th>\n";
if ($sort == 'set') echo "    <th class=\"primary\">Set</th>\n";
else echo "    <th><a href=\"index.php?show=items&amp;sort=set\">Set</a></th>\n";
echo "  </tr>\n";
$isOdd = 1;
while ($row = pg_fetch_row($result)) {
	if ($isOdd) echo "  <tr class=\"odd\">\n";
	else echo "  <tr class=\"even\">\n";
	$itemUrlName = urlencode($row[0]);
	echo "    <td class=\"primary\"><a href=\"index.php?show=item&amp;item=$itemUrlName\">$row[0]</a></td>
		<td class=\"numeric\">$row[1]</td>
		<td class=\"numeric\">$row[2]</td>
		<td class=\"numeric\">$row[4]</td>
		</tr>\n";
	$isOdd = !$isOdd;
}

echo "  </table>\n

   <h3>Class Distribution</h3>\n";

   for ($tier = 1; $tier != 4; $tier++) {
   echo "
   <p>Number of tier-$tier epic set pieces dropped, by set:</p>
   <table>
   <tr>
   <th>Set Name</th>
   <th>Drops</th>
   <th>% of All Tier-$tier Drops</th>
   </tr>\n";

   $result = pg_query($db, "SELECT S.name, COUNT(*), TO_CHAR((COUNT(*)::real/(SELECT COUNT(*)::real FROM Bids B, Items I, Sets S WHERE B.item = I.item AND I.set_id = S.id AND S.tier = " . pg_escape_string($tier) . "))*100,'999D9') FROM Bids B, Sets S, Items I WHERE B.item = I.item AND I.set_id = S.id AND S.tier = " . pg_escape_string($tier) . " GROUP BY S.name, S.class ORDER BY S.class ASC;");
   if (!$result) { echo "  <p class=\"error\">Couldn't get set drop counts: " . pg_last_error($db) . "</p>\n"; require 'footer.php'; exit; }
   if (pg_num_rows($result) == 0) {
     echo "   <tr><td colspan=\"3\"><i>No drops of this tier yet.</i></td></tr>";
   }
   $isOdd = 1;
   while ($row = pg_fetch_row($result)) {
   if ($isOdd) echo "   <tr class=\"odd\">";
   else echo "   <tr class=\"even\">";
   echo "    <td class=\"primary\">$row[0]</td>
   <td class=\"numeric\">$row[1]</td>
   <td class=\"numeric\">$row[2]%</td>
   </tr>\n";
   $isOdd = !$isOdd;
   }
   echo "  </table>\n";
   }

?>
