<?php

echo "  <h1>Raid Details</h1>";

$query = "SELECT R.date, R.instance, R.note FROM Raids R WHERE R.raid_id = " . pg_escape_string(stripslashes($_GET['id'])) . ";";
$result = pg_query($db, $query);
if (!$result) { echo "  <p class=\"error\">Couldn't get raid information: " . pg_last_error($db) . "</p>\n"; require 'footer.php'; exit; }
$row = pg_fetch_row($result);
$dateCutoff  = $row[0];
echo "  <p><b>Date:</b> $row[0]<br />
<b>Instance:</b> $row[1]<br />
<b>Note:</b> $row[2]<br />\n";

$sort = 'player';
if (stripslashes($_GET['sort']) == 'class') $sort = 'class';
else if (stripslashes($_GET['sort']) == 'dkp') $sort = 'dkp';
else if (stripslashes($_GET['sort']) == 'credit') $sort = 'credit';

$query = "SELECT P.active, P.class, P.name, D.amount, (CASE WHEN T.total IS NULL THEN 0 ELSE T.total END) AS prev_dkp, D.change_id FROM Players P, DKP D LEFT JOIN (SELECT D2.name AS name, SUM(CASE WHEN B.item IS NULL THEN D2.amount ELSE D2.amount*-1 END) AS total FROM Raids R, DKP D2 LEFT JOIN Bids B ON B.change_id = D2.change_id WHERE D2.raid_id = R.raid_id AND R.date < '" . pg_escape_string($dateCutoff) . "' GROUP BY D2.name) AS T ON T.name = D.name LEFT JOIN Bids B ON B.change_id = D.change_id WHERE B.change_id IS NULL AND P.name = D.name AND D.raid_id = " . pg_escape_string(stripslashes($_GET['id'])) . " ";
if ($sort == 'player') $query .= "ORDER BY P.name ASC;";
else if ($sort == 'class') $query .= "ORDER BY P.class ASC, prev_dkp DESC;";
else if ($sort == 'dkp') $query .= "ORDER BY prev_dkp DESC, P.name ASC;";
else if ($sort == 'credit') $query .= "ORDER BY D.amount DESC, P.name ASC;";

$result = pg_query($db, $query);
if (!$result) { echo "  <p class=\"error\">Couldn't get participating players: " . pg_last_error($db) . "</p>\n"; require 'footer.php'; exit; }
if (pg_num_rows($result)) {
	echo "  <h2>Players in Attendance</h2>
		<table>
		<tr>\n";
	if ($sort == 'player') echo "    <th class=\"primary\">Player</th>\n";
	else echo "    <th><a href=\"index.php?show=raid&amp;id=" . stripslashes($_GET['id']) . "\">Player</a></th>\n";
	if ($sort == 'credit') echo "    <th class=\"primary\">Credit</th>\n";
	else echo "    <th><a href=\"index.php?show=raid&amp;id=" . stripslashes($_GET['id']) . "&sort=credit\">Credit</a></th>\n";
	if ($sort == 'dkp') echo "    <th class=\"primary\">DKP at Start</th>\n";
	else echo "    <th><a href=\"index.php?show=raid&amp;id=" . stripslashes($_GET['id']) . "&sort=dkp\">DKP at Start</a></th>\n";
	if ($sort == 'class') echo "    <th class=\"primary\">Class</th>\n";
	else echo "    <th><a href=\"index.php?show=raid&amp;id=" . stripslashes($_GET['id']) . "&sort=class\">Class</a></th>\n";
	echo "    <th>Admin</th>
		</tr>";
	while ($row = pg_fetch_row($result)) {
		if ($row[1] == '') $row[1] = 'Unspecified';
		if ($row[0] == 't') {
			echo "
				<tr class=\"class-" . $row[1] . "\">
				<td class=\"primary\"><a href=\"index.php?show=player&amp;name=$row[2]\">$row[2]</a></td>
				<td class=\"numeric\">$row[3]</td>
				<td class=\"numeric\">$row[4]</td>
				<td>$row[1]</td>
				<td><a href=\"edit-dkp.php?id=" . $row[5] . "\">Edit</a></td>
				</tr>";
		}
		else {
			echo "
				<tr class=\"class-Unspecified\">
				<td class=\"primary\"><span class=\"disabled\">$row[2]</span></td>
				<td class=\"numeric\"><span class=\"disabled\">$row[3]</span></td>
				<td class=\"numeric\"><span class=\"disabled\">$row[4]</span></td>
				<td><span class=\"disabled\">$row[1]</span></td>
				<td><a href=\"edit-dkp.php?id=" . $row[5] . "\">Edit</a></td>
				</tr>";
		}
	}
	echo "
		</table>\n\n";
}
else {
	echo "  <p>No current guild members participated in this run.</p>\n\n";
}

echo "  <h2>Loot Acquired</h2>\n";
$query = "SELECT I.item, P.name, D.amount, D.change_id FROM Items I, Players P, DKP D INNER JOIN Bids B ON B.change_id = D.change_id WHERE P.name = D.name AND B.item = I.item AND D.raid_id = " . pg_escape_string(stripslashes($_GET['id'])) . " ORDER BY D.name ASC;";
$result = pg_query($db, $query);
if (!$result) { echo "  <p class=\"error\">Couldn't get loot list: " . pg_last_error($db) . "</p>\n"; }
if (pg_num_rows($result)) {
	echo "  <table>
		<tr>
		<th>Item</th>
		<th class=\"primary\">Player</th>
		<th>Bid</th>
		<th>Admin</th>
		</tr>\n";
	$isOdd = 1;
	while ($row = pg_fetch_row($result)) {
		if ($isOdd) echo "  <tr class=\"odd\">\n";
		else echo "  <tr class=\"even\">\n";
		$itemNameFormatted = urlencode($row[0]);
		echo "    <td class=\"primary\"><a href=\"index.php?show=item&amp;item=$itemNameFormatted\">$row[0]</a></td>
			<td><a href=\"index.php?show=player&amp;name=" . $row[1] . "\">$row[1]</a></td>
			<td class=\"numeric\">$row[2]</td>
			<td><a href=\"edit-dkp.php?id=" . $row[3] . "\">Edit</a></td>
			</tr>\n";
		$isOdd = !$isOdd;
	}
	echo "
		</table>\n\n";
}
else {
	echo "  <p>No loot acquired this run.</p>\n\n";
}
echo "  <p><b>Administrator:</b> <a href=\"edit-raid.php?id=" . stripslashes($_GET['id']) . "\">Edit this raid or its DKP credits</a> or <a href=\"remove-raid.php?id=" . stripslashes($_GET['id']) . "\">Remove this raid</a></p>\n";
?>
