<?php

if (verifyPassword($db, stripslashes($_POST['password']), array(PERM_MODIFY_MEMBERS => TRUE))) {

	$instanceNameForCode = array(
			'mc' => "'Molten Core'",
			'ony' => "'Onyxia\\'s Lair'",
			'bwl' => "'Blackwing Lair'",
			'mcbwl' => "'Molten Core', 'Blackwing Lair'",
			'all' => "'Molten Core', 'Blackwing Lair', 'Onyxia\\'s Lair'"
			);

	$sort = 'name';
	if (stripslashes($_GET['sort']) == 'class') $sort = 'class';
	if (stripslashes($_GET['sort']) == 'WAp') $sort = 'WAp';
	if (stripslashes($_GET['sort']) == 'WAp4') $sort = 'WAp4';
	if (stripslashes($_GET['sort']) == 'WA') $sort = 'WA';
	if (stripslashes($_GET['sort']) == 'A') $sort = 'A';
	if (stripslashes($_GET['sort']) == 'W') $sort = 'W';
	if (stripslashes($_GET['sort']) == 'R0') $sort = 'R0';
	if (stripslashes($_GET['sort']) == 'Rf') $sort = 'Rf';

	$instanceCode = 'bwl';
	if (stripslashes($_GET['instance']) == 'mc') $instanceCode = 'mc';
	if (stripslashes($_GET['instance']) == 'ony') $instanceCode = 'ony';
	if (stripslashes($_GET['instance']) == 'mcbwl') $instanceCode = 'mcbwl';
	if (stripslashes($_GET['instance']) == 'all') $instanceCode = 'all';
	$instanceNames = $instanceNameForCode[$instanceCode];

	$getVarString = '?show=stats';
	if (stripslashes($_GET['name'])) $getVarString .= '&name=' . stripslashes($_GET['name']);
	if (stripslashes($_GET['instance'])) $getVarString .= '&instance=' . stripslashes($_GET['instance']);
	$getVarString .= '&';

	echo "<form method=\"get\" action=\"index.php\">
		<input type=\"hidden\" name=\"show\" value=\"stats\" />\n";
	if (stripslashes($_GET['name'])) echo "<input type=\"hidden\" name=\"name\" value=\"" . stripslashes($_GET['name']) . "\" />\n";
	if (stripslashes($_GET['sort'])) echo "<input type=\"hidden\" name=\"sort\" value=\"" . stripslashes($_GET['sort']) . "\" />\n";
	echo "<p><b>Instances</b>: <select name=\"instance\">\n";
	if ($instanceCode == 'mc') echo "<option selected=\"true\" value=\"mc\">Molten Core</option>\n";
	else echo "<option value=\"mc\">Molten Core</option>\n";
	if ($instanceCode == 'ony') echo "<option selected=\"true\" value=\"ony\">Onyxia's Lair</option>\n";
	else echo "<option value=\"ony\">Onyxia's Lair</option>\n";
	if ($instanceCode == 'bwl') echo "<option selected=\"true\" value=\"bwl\">Blackwing Lair</option>\n";
	else echo "<option value=\"bwl\">Blackwing Lair</option>\n";
	if ($instanceCode == 'mcbwl') echo "<option selected=\"true\" value=\"mcbwl\">MC and BWL</option>\n";
	else echo "<option value=\"mcbwl\">MC and BWL</option>\n";
	if ($instanceCode == 'all') echo "<option selected=\"true\" value=\"all\">All 40-mans</option>\n";
	else echo "<option value=\"all\">All 40-mans</option>\n";
	echo "</select>
		<input type=\"submit\" value=\"Show\" />
		</p>
		</form>\n";

	$query = "SELECT SUM(CASE WHEN date >= CURRENT_DATE - INTERVAL '28 DAYS' THEN 1 ELSE 0 END) AS raids_last_four_weeks, COUNT(1) AS total_raids, SUM(CASE WHEN EXTRACT(WEEK FROM date) = EXTRACT(WEEK FROM CURRENT_DATE) - 1 AND EXTRACT(YEAR FROM date) = EXTRACT(YEAR FROM CURRENT_DATE) THEN 1 ELSE 0 END) AS raids_prev_week, MAX(date) - MIN(date) AS total_days_raiding FROM Raids R WHERE instance IN ($instanceNames);";
	$result = pg_query($db, $query);
	if (!$result) { echo "  <p class=\"error\">Couldn't get general raiding statistics: " . pg_last_error($db) . "</p>\n"; require 'footer.php'; exit; }
	$generalRaidInfo = pg_fetch_assoc($result);

	$query = "SELECT name, class, COUNT(1) AS attended_all_time, SUM(CASE WHEN date >= CURRENT_DATE - INTERVAL '28 DAYS' THEN 1 ELSE 0 END) AS attended_last_four_weeks, SUM(CASE WHEN EXTRACT(WEEK FROM date) = EXTRACT(WEEK FROM CURRENT_DATE) - 1 AND EXTRACT(YEAR FROM date) = EXTRACT(YEAR FROM CURRENT_DATE) THEN 1 ELSE 0 END) AS attended_prev_week, MIN(date) AS raiding_start, MAX(DATE) AS raiding_stop, MAX(date) - MIN(date) + 1 AS days_raiding FROM Raids R CROSS JOIN Players P LEFT JOIN DKP D USING (name,raid_id) LEFT JOIN Bids B USING (change_id) WHERE active = TRUE AND instance IN ($instanceNames) AND D.change_id IS NOT NULL AND B.change_id IS NULL GROUP BY class, name ";
	switch ($sort) {
		case 'name': $query .= 'ORDER BY name ASC;'; break;
		case 'class': $query .= 'ORDER BY class ASC, name ASC;'; break;
		case 'WAp': $query .= 'ORDER BY attended_prev_week DESC, name ASC;'; break;
		case 'WAp4': $query .= 'ORDER BY attended_last_four_weeks DESC, name ASC;'; break;
		case 'WA':
		case 'A': $query .= 'ORDER BY attended_all_time DESC, name ASC;'; break;
		case 'R0': $query .= 'ORDER BY raiding_start ASC, name ASC;'; break;
		case 'Rf': $query .= 'ORDER BY raiding_stop DESC, name ASC;'; break;
		case 'W': $query .= 'ORDER BY days_raiding DESC, name ASC;'; break;
	}
	$result = pg_query($db, $query);
	if (!$result) { echo "  <p class=\"error\">Couldn't get player-specific raiding statistics: " . pg_last_error($db) . "</p>\n"; require 'footer.php'; exit; }

	echo "<table>\n<tr>\n";
	if ($sort == 'name') echo "<th class=\"primary\">Player</th>\n";
	else echo "<th><a href=\"index.php?show=stats&amp;" . $getVarString . "sort=name\">Player</a></th>\n";
	if ($sort == 'class') echo "<th class=\"primary\">Class</th>\n";
	else echo "<th><a href=\"index.php?show=stats&amp;" . $getVarString . "sort=class\">Class</a></th>\n";
	if ($sort == 'WAp') echo "<th class=\"primary\">WA<sub>p</sub></th>\n";
	else echo "<th><a href=\"index.php?show=stats&amp;" . $getVarString . "sort=WAp\">WA<sub>p</sub></a></th>\n";
	if ($sort == 'WAp4') echo "<th class=\"primary\">WA<sub>p4</sub></th>\n";
	else echo "<th><a href=\"index.php?show=stats&amp;" . $getVarString . "sort=WAp4\">WA<sub>p4</sub></a></th>\n";
	if ($sort == 'WA') echo "<th class=\"primary\">WA</th>\n";
	else echo "<th><a href=\"index.php?show=stats&amp;" . $getVarString . "sort=WA\">WA</a></th>\n";
	echo "<th class=\"separator\">&nbsp;</th>\n";
	if ($sort == 'A') echo "<th class=\"primary\">A</th>\n";
	else echo "<th><a href=\"index.php?show=stats&amp;" . $getVarString . "sort=A\">A</a></th>\n";
	if ($sort == 'W') echo "<th class=\"primary\">W</th>\n";
	else echo "<th><a href=\"index.php?show=stats&amp;" . $getVarString . "sort=W\">W</a></th>\n";
	if ($sort == 'R0') echo "<th class=\"primary\">R<sub>0</sub></th>\n";
	else echo "<th><a href=\"index.php?show=stats&amp;" . $getVarString . "sort=R0\">R<sub>0</sub></a></th>\n";
	if ($sort == 'Rf') echo "<th class=\"primary\">R<sub>f</sub></th>\n";
	else echo "<th><a href=\"index.php?show=stats&amp;" . $getVarString . "sort=Rf\">R<sub>f</sub></a></th>\n";
	echo "<th>P</th>\n</tr>\n";

	while ($row = pg_fetch_assoc($result)) {
		$prevWeekPct = $row['attended_prev_week']/$generalRaidInfo['raids_prev_week'];
		$prev4WkPct = ($row['attended_last_four_weeks']/4)/($generalRaidInfo['raids_last_four_weeks']/4);
		if ($prevWeekPct >= .66) $playerStatus = 'core';
		elseif ($prev4WkPct >= .66) $playerStatus = 'question';
		else $playerStatus = 'casual';

		$stat_WAp = $row['attended_prev_week'] . " of " . $generalRaidInfo['raids_prev_week'];
		$stat_WAp4 = round($row['attended_last_four_weeks']/4) . " of " . round($generalRaidInfo['raids_last_four_weeks']/4);
		$stat_WA = round(7*$row['attended_all_time']/$generalRaidInfo['total_days_raiding']) . " of " . round(7*$generalRaidInfo['total_raids']/$generalRaidInfo['total_days_raiding']);
		$stat_W = ceil($row['days_raiding']/7);
		$stat_P = round($row['days_raiding']/$row['attended_all_time'], 1);

		if ($row['name'] == stripslashes($_GET['name'])) echo "<tr class=\"$playerStatus\" id=\"highlight\">\n";
		else echo "<tr class=\"$playerStatus\">\n";
		echo "<td class=\"primary\"><a href=\"index.php?show=player&name=" . $row['name'] . "\">" . $row['name'] . "</a></td>
			<td>" . $row['class'] . "</td>
			<td>$stat_WAp</td>
			<td>$stat_WAp4</td>
			<td>$stat_WA</td>
			<td class=\"separator\">&nbsp;</td>
			<td class=\"numeric\">" . $row['attended_all_time'] . "</td>
			<td class=\"numeric\">$stat_W</td>
			<td>" . $row['raiding_start'] . "</td>
			<td>" . $row['raiding_stop'] . "</td>
			<td class=\"numeric\">$stat_P</td>
			</tr>";
	}
	echo "</table>\n";

}
else {
	echo "  <p class=\"error\">The supplied administrator password was incorrect.</p>
		<p class=\"goback\">Return to the <a href=\"index.php\">player list</a>.</p>";
}

?>

<h3>Column Descriptions</h3>
<p><b>WA<sub>p</sub>:</b> The <i>previous week's attendance</i>. This is how many of last week's raids the player attended. It's a straightforward indicator of whether a player qualifies for core-raider status.</p>
<p><b>WA<sub>p4</sub>:</b> The <i>week-to-week attendance for the last four weeks</i>. This is the average number of raids the player attended per week for the last four weeks, as compared to the average number of raids that were run per week for the last four weeks.  Compare this to <b>WA<sub>p</sub></b>; use it as a check to see if a player with declining attendance is having a long-term attenuation, or if it is potentially temporary.</p>
<p><b>WA:</b> The <i>week-to-week attendance since the guild started raiding</i>. This is the average number of raids the player attended per week since the guild began raiding, as compared to the average number of raids that were run per week since the guild began raiding. This statistic is only useful for players that have been raiding for a majority of the guild's existence (at least 70% or so); for those players, it can be used to notice extremely long-term changes in raiding habits.</p>
<p><b>A:</b> The <i>total attendance</i>. This is the number of raids the player has been on total.</p>
<p><b>W:</b> The <i>raiding span, in weeks</i>. This is the number of weeks between the player's earliest and most recent raids.</p>
<p><b>R<sub>0</sub>:</b> The date of the player's first raid.</p>
<p><b>R<sub>f</sub>:</b> The date of the player's most recent raid.</p>
<p><b>P:</b> The <i>raiding period, in days</i>. This is the average number of days between raids that the player participates in. On average, if a player attends a raid, this many days will pass before he or she attends his or her next raid.</p>
<h3>Color Descriptions</h3>
<p><b style="background-color: #ddffdd">Green rows</b> indicate members who qualify for core-raider status, based on last week's attendance.<br />
<b style="background-color: #ffffdd">Yellow rows</b> indicate members who (on average) qualified for core-raider status over the last four weeks, but did not this week. Thus, these members may soon lose their core-raider status unless they increase their attendance.<br />
<b style="background-color: #ffdddd">Red rows</b> indicate members who do not qualify for core-raider status.</p>
<p class="goback">Return to the <a href="index.php?show=players">player list</a>.</p>

<?php
